<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['gazelle.hl7mpr.submitProfile']}"/>
    <ui:param name="pageNameUrl" value="profiles/submitProfile.seam"/>
    <ui:param name="pageNameTitle" value="#{messages['gazelle.hl7mpr.submitProfile']}"/>
    <ui:define name="body">
        <h:form id="globalForm">
            <rich:messages globalOnly="true" styleClass="message"/>
            #{creationManagerBean.initialize()}
            <h1>#{messages['gazelle.hl7mpr.profileDetails']}</h1>
            <s:div id="globalDiv">
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['gazelle.hl7mpr.profileDetails']}
                    </ui:define>
                    <h:outputText>#{messages['gazelle.hl7mpr.referencedEndpoint']} #{creationManagerBean.linkedTF}
                    </h:outputText>
                    <div class="row">

                        <div class="col-lg-8">
                            <ui:decorate template="/layout/panels/_panel_footer.xhtml">
                                <div class="form-horizontal">
                                    <a4j:region id="domainRegion">
                                        <s:decorate id="domainDecorate"
                                                    template="/layout/form/_form_field_horizontal_inline.xhtml">
                                            #{creationManagerBean.loadListOfDomains()}
                                            <ui:param name="id" value="domainRegionId"/>
                                            <ui:param name="required" value="true"/>
                                            <ui:define name="label">
                                                <h:outputText value="#{messages['gazelle.hl7mpr.Domain']}"/>
                                            </ui:define>
                                            <h:selectOneMenu id="domainRegionId"
                                                             value="#{creationManagerBean.selectedDomainKeyword}"
                                                             styleClass="form-control gzl-select-text"
                                                             rendered="#{creationManagerBean.availableDomains != null}">
                                                <f:selectItem noSelectionOption="true" itemValue="#{null}" itemLabel="#{messages['gazelle.simulator.PleaseSelect']}" />
                                                <f:selectItems value="#{creationManagerBean.availableDomains}"
                                                               var="domain"
                                                               label="#{domain}"/>
                                                <a4j:ajax event="change" render="globalDiv"/>
                                            </h:selectOneMenu>
                                            <s:div rendered ="#{creationManagerBean.availableDomains == null}">
                                                <s:span styleClass="gzl-icon-exclamation-triangle"/>
                                                <h:outputText value="No available Domain" styleClass="gzl-text-orange"/>
                                            </s:div>
                                        </s:decorate>
                                    </a4j:region>
                                    <a4j:region id="actorRegion">
                                        <s:decorate id="actorDecorate"
                                                    template="/layout/form/_form_field_horizontal_inline.xhtml"
                                                    rendered="#{creationManagerBean.selectedDomainKeyword != null}">
                                            #{creationManagerBean.loadListOfActorsForDomain()}
                                            <ui:param name="id" value="actorRegionId"/>
                                            <ui:param name="required" value="true"/>
                                            <ui:define name="label">
                                                <h:outputText value="#{messages['gazelle.hl7mpr.Actor']}"/>
                                            </ui:define>
                                            <h:selectOneMenu id="actorRegionId"
                                                             value="#{creationManagerBean.selectedActorKeyword}"
                                                             styleClass="form-control gzl-select-text"
                                                             rendered="#{creationManagerBean.availableActors != null}">
                                                <f:selectItem noSelectionOption="true" itemValue="#{null}" itemLabel="#{messages['gazelle.simulator.PleaseSelect']}" />
                                                <f:selectItems value="#{creationManagerBean.availableActors}"
                                                               var="actor"
                                                               label="#{actor}"/>
                                                <a4j:ajax event="change" render="globalDiv"/>
                                            </h:selectOneMenu>
                                            <s:div rendered ="#{creationManagerBean.availableActors == null}">
                                                <s:span styleClass="gzl-icon-exclamation-triangle"/>
                                                <h:outputText value="No available Actor for selected Domain" styleClass="gzl-text-orange"/>
                                            </s:div>
                                        </s:decorate>
                                    </a4j:region>
                                    <a4j:region id="transactionRegion">
                                        <s:decorate id="transactionDecorate"
                                                    template="/layout/form/_form_field_horizontal_inline.xhtml"
                                                    rendered="#{creationManagerBean.selectedActorKeyword != null}">
                                            #{creationManagerBean.loadListOfTransactionsForActor()}
                                            <ui:param name="id" value="transactionRegionId"/>
                                            <ui:param name="required" value="true"/>
                                            <ui:define name="label">
                                                <h:outputText value="#{messages['gazelle.hl7mpr.Transaction']}"/>
                                            </ui:define>
                                            <h:selectOneMenu id="transactionRegionId"
                                                             value="#{creationManagerBean.selectedTransactionKeyword}"
                                                             styleClass="form-control gzl-select-text"
                                                             rendered="#{creationManagerBean.availableTransactions != null}">
                                                <f:selectItem noSelectionOption="true" itemValue="#{null}" itemLabel="#{messages['gazelle.simulator.PleaseSelect']}" />
                                                <f:selectItems value="#{creationManagerBean.availableTransactions}"
                                                               var="transaction" label="#{transaction}"/>
                                                <a4j:ajax event="change" render="buttonsDiv"
                                                          listener="#{creationManagerBean.enableSubmit()}"/>
                                            </h:selectOneMenu>
                                            <s:div rendered ="#{creationManagerBean.availableTransactions == null}">
                                                <s:span styleClass="gzl-icon-exclamation-triangle"/>
                                                <h:outputText value="No available Transaction for selected Domain and Actor" styleClass="gzl-text-orange"/>
                                            </s:div>
                                        </s:decorate>
                                    </a4j:region>

                                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                        <ui:param name="id" value="triggerEventDecorate"/>
                                        <ui:param name="required" value="true"/>
                                        <ui:define name="label">
                                            <h:outputText value="#{messages['gazelle.hl7mpr.TriggerEvent']}"/>
                                        </ui:define>
                                        <h:inputText id="triggerEventDecorate"
                                                     value="#{creationManagerBean.selectedReference.triggerEvent}"
                                                     styleClass="form-control"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                        <ui:param name="id" value="moccDecorate"/>
                                        <ui:define name="label">
                                            <h:outputText
                                                    value="#{messages['gazelle.hl7mpr.MessageOrderControlCode']}"/>
                                        </ui:define>
                                        <h:inputText id="moccDecorate"
                                                     value="#{creationManagerBean.selectedReference.messageOrderControlCode}"
                                                     styleClass="form-control"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                        <ui:param name="id" value="versionDecorate"/>
                                        <ui:param name="required" value="true"/>
                                        <ui:define name="label">
                                            <h:outputText value="#{messages['gazelle.hl7mpr.Hl7Version']}"/>
                                        </ui:define>
                                        <h:inputText id="versionDecorate"
                                                     value="#{creationManagerBean.selectedReference.hl7Version}"
                                                     styleClass="form-control"/>
                                    </s:decorate>

                                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                        <ui:param name="id" value="oidDecorate"/>
                                        <ui:define name="label">
                                            <h:outputText value="#{messages['gazelle.hl7mpr.profileOid']}"/>
                                            <span class="gzl-icon-question-circle" title="If you do not choose an OID, it will be automatically generated on Submit"/>
                                        </ui:define>
                                        <div class="col-sm-8 gzl-no-padding-left">
                                            <h:inputText id="oidDecorate"
                                                         value="#{creationManagerBean.selectedReference.oid}"
                                                         styleClass="form-control"/>
                                        </div>
                                        <div class="col-sm-4">
                                            <a4j:commandButton id="submitButton"
                                                               actionListener="#{creationManagerBean.getANewOID()}"
                                                               styleClass="gzl-btn-blue"
                                                               value="#{messages['gazelle.hl7mpr.requestOid']}"
                                                               render="oidDecorate"/>
                                        </div>
                                    </s:decorate>



                                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                        <ui:param name="id" value="javaPackage"/>
                                        <ui:define name="label">
                                            <h:outputText value="#{messages['gazelle.hl7.validator.JavaPackage']}"/>
                                        </ui:define>
                                        <h:inputText id="javaPackage"
                                                     value="#{creationManagerBean.javaPackage}"
                                                     styleClass="form-control"/>
                                    </s:decorate>

                                    <a4j:region id="format">
                                        <s:decorate id="formatDecorate"
                                                    template="/layout/form/_form_field_horizontal_inline.xhtml">
                                            <ui:param name="id" value="formatId"/>
                                            <ui:param name="required" value="true"/>
                                            <ui:define name="label">
                                                <h:outputText value="#{messages['net.ihe.gazelle.hl7.Format']}"/>
                                            </ui:define>

                                            <h:selectOneMenu id="formatId"
                                                             value="#{creationManagerBean.conformanceProfileFormat}"
                                                             styleClass="form-control gzl-select-text">
                                                <f:selectItem noSelectionOption="true" itemValue="#{null}" itemLabel="#{messages['gazelle.simulator.PleaseSelect']}" />
                                                <f:selectItem itemValue = "HL7v2xConformanceProfile" itemLabel = "HL7v2xConformanceProfile" />
                                                <f:selectItem itemValue = "ConformanceProfile" itemLabel = "ConformanceProfile" />

                                            </h:selectOneMenu>
                                        </s:decorate>
                                    </a4j:region>

                                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                        <ui:param name="id" value="pathInput"/>
                                        <ui:param name="required" value="true"/>
                                        <ui:define name="label">
                                            <h:outputText value="#{messages['net.ihe.gazelle.hl7.Path']}"/>
                                        </ui:define>
                                        <div class="col-sm-4 gzl-no-padding-left">
                                            <h:inputText styleClass="form-control" id="pathInput"
                                                         value="#{creationManagerBean.profilePath}"  style="width:300;"/>
                                        </div>
                                        <div class="col-sm-8">
                                            <a4j:commandButton value="#{messages['net.ihe.gazelle.hl7.DefaultPath']}"
                                                               actionListener="#{creationManagerBean.generatePath()}"
                                                               render="pathInput" styleClass="gzl-btn-blue"/>
                                        </div>
                                    </s:decorate>

                                </div>

                                <ui:define name="panel_footer">
                                    <s:div id="buttonsDiv">
                                        <a4j:commandButton id="submitButton"
                                                           actionListener="#{creationManagerBean.submitNewProfile()}"
                                                           styleClass="gzl-btn-green"
                                                           value="#{messages['gazelle.hl7mpr.submit']}"
                                                           render="globalDiv"/>
                                                           <!--rendered ="#{creationManagerBean.displaySubmitButton}"-->

                                        <a4j:commandButton id="resetButton" onclick="#{rich:component('panelLoading')}.show();"
                                                           oncomplete="#{rich:component('panelLoading')}.hide();"
                                                           styleClass="gzl-btn-orange"
                                                           actionListener="#{creationManagerBean.initialize()}"
                                                           value="#{messages['gazelle.hl7mpr.Reset']}" render="globalDiv"/>
                                    </s:div>
                                </ui:define>
                            </ui:decorate>
                        </div>
                    </div>
                </ui:decorate>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
